package name.dhiller.jBorderLiner;

//import com.sun.star.uno.UnoRuntime;       // unused?
import com.sun.star.uno.XComponentContext;
import com.sun.star.lib.uno.helper.WeakBase;
//import javax.swing.JOptionPane;             // for Messagebox TEST only

/**
 * @author d.hiller
 * @version 080127
 */
class BLKeyHandlerImpl extends WeakBase
   implements com.sun.star.awt.XKeyHandler
{
    private final XComponentContext m_xContext;
    private final com.sun.star.frame.XFrame m_xFrame;
    private static final String m_implementationName = BLKeyHandlerImpl.class.getName();

    BLKeyHandlerImpl( com.sun.star.frame.XFrame xFrame, XComponentContext context )
    {
        m_xFrame = xFrame;
        m_xContext = context;
    };

    // com.sun.star.lang.XEventListener:
    public void disposing(com.sun.star.lang.EventObject Source)
    {
        // nothing to do here
    }

    /**
     * react on key pressed: ESC: end key listening, ALT, CTRL, SHIFT+Num1..NUM9
     * do borders
     * @author dhiller
     * @version 071220
     * @param aEvent - com.sun.star.awt.KeyEvent: Event.KeyCode, .Modifiers
     * @return false: key was not for me, true: do not process key
     */
    // com.sun.star.awt.XKeyHandler:
    public boolean keyPressed(com.sun.star.awt.KeyEvent aEvent)
    {
        // NOTE: Default initialized polymorphic structs can cause problems
        // because of missing default initialization of primitive types of
        // some C++ compilers or different Any initialization in Java and C++
        // polymorphic structs.
        boolean bKeep = false;
        if (aEvent.KeyCode == com.sun.star.awt.Key.ESCAPE) {
            jBorderLiner.TB_Active.setStatus(m_xFrame, false);
            bKeep = true;
        }
        else if ((aEvent.Modifiers > 0) && (aEvent.KeyCode >= com.sun.star.awt.Key.NUM1)
                && (aEvent.KeyCode <= com.sun.star.awt.Key.NUM9)) {
            Borders.DoBorders (m_xFrame, aEvent.Modifiers, aEvent.KeyCode);
            bKeep = true;
        }
        return bKeep;
    }

    public boolean keyReleased(com.sun.star.awt.KeyEvent aEvent)
    {
        // NOTE: Default initialized polymorphic structs can cause problems
        // because of missing default initialization of primitive types of
        // some C++ compilers or different Any initialization in Java and C++
        // polymorphic structs.
        return false;// ' do forward key action to others
    }
}
