/*
 * BL_TB_ActiveBtn.java
 * Created on 2. Dezember 2007, 18:44
 * BorderLiner Toolbar Active Button
 */

package name.dhiller.jBorderLiner;

import com.sun.star.beans.NamedValue;
//import com.sun.star.table.BorderLine;
import java.lang.Math;

/**
 * @author Dhiller
 * @version 120204
 * 
 * LineStyles (inner, distance, outer):
 * 0,1,2: SOLID, DOTTED, DASHED (0, 0, w)
 * 3: DOUBLE (w, w(min. 35), w)
 * 4: THINTHICK_SMALLGAP (26, 35, w)
 * 5: THINTHICK_MEDIUMGAP (w/2, w/2(min 35), w)
 * 6: THINTHICK_LARGEGAP (26, w(min 35), 53)
 * 7: THICKTHIN_SMALLGAP (w, 35, 26)
 * 8: THICKTHIN_MEDIUMGAP (w, w/2(min 35), w/2)
 * 9: THICKTHIN_LARGEGAP (53, w(min 35), 26)
 * 10,11:EMBOSSED, ENGRAVED (w/2, w(min 35), w/2)
 * 12:OUTSET (w, w(min 35), 26)
 * 13:INSET (26, w(min 35), w)
 */
class BL_TB_SelectLSBtn extends BL_ToolbarItem {
    //private static com.sun.star.frame.XFrame mxFrame; // never read locally
    static short icurrentLinestyle;
                                // OuterLineWidth, InnerLineWidth, LineDistance
    private static final short[][] LSList = { {0,0,0}, {35,0,0}, {2,0,0}, {18,0,0},
        {88,0,0}, {141,0,0}, {176,0,0}, {2,2,35}, {2,2,88}, {35,35,35}, 
        {88,88,88}, {35,2,88}, {88,2,88}, {141,2,88}, {88,35,88}, {35,88,35}, 
        {141,88,88}, {88,141,88} };
    private static final short iInitialValue = 1;
    private static final short iLowerLimit = 0;
    private static final short iUpperLimit = 14;
    private static final short iStep = 1;
    
    /** Creates a new instance of BL_TB_ActiveBtn */
    BL_TB_SelectLSBtn() {
        super();
        icurrentLinestyle = iInitialValue-1;
    }
    
    /** init - Initialize Toolbarbutton to select the linestyle
     * @param com.sun.star.frame.XStatusListener xControl
     * @param com.sun.star.util.URL my URL
     *{@inheritDoc}
     */
    void Init(com.sun.star.frame.XFrame xFrame,
              com.sun.star.frame.XStatusListener xControl,
              com.sun.star.util.URL aURL) {

       super.Init (xFrame, xControl, aURL, null);

       NamedValue[] loadArgs = new NamedValue[4];

       loadArgs[0]=new NamedValue();
       loadArgs[0].Name = "Step";
       loadArgs[0].Value = iStep;
                
       loadArgs[1]=new NamedValue();
       loadArgs[1].Name = "LowerLimit";
       loadArgs[1].Value = iLowerLimit;

       loadArgs[2]=new NamedValue();
       loadArgs[2].Name = "UpperLimit";
       loadArgs[2].Value = iUpperLimit;
 
       loadArgs[3]=new NamedValue();
       loadArgs[3].Name = "Value";
       short sLP = LineStyleToListPos(icurrentLinestyle);
       loadArgs[3].Value = sLP;

       // new toolbar, need only to inform this of the value the others already have
       SendCommandTo(xControl, new String("SetValues"), loadArgs);
           
                                                    // update linestylepreview
       jBorderLiner.TB_LSPreview.setLinestyle(sLP);
    }
    
    /** dispatch - got a message, act
     * @param com.sun.star.util.URL my URL
     * @param com.sun.star.beans.PropertyValue[] Arguments, Name = "KeyModifier", "Value"
     */
    void dispatch( com.sun.star.util.URL aURL,
                           com.sun.star.beans.PropertyValue[] aArguments) {
       int i;
       String sValue = new String();
       for (i=0; i < aArguments.length; i++) {
           if (aArguments[i].Name.equals("Value")) {
               sValue = aArguments[i].Value.toString();
               break;
           }
       }
       
       if (!sValue.equals(null)) {
//    	   System.out.println(sValue);
           setLineNumberFromTB(Integer.parseInt(sValue));
       }
    }
    
    /** set line style
     * need to write value to toolbar again in case user entered data manually
     * and also to inform all toolbars of the change
     * 
     * @param iLS - Linestyle
     */
    void setLineNumberFromTB(int iLP) {
    	short truncLP = (short) Math.max(iLowerLimit, iLP);
    	truncLP = (short) Math.min(iUpperLimit, truncLP);
        
        icurrentLinestyle = LinePosToLineStyle(truncLP); 
    	
        NamedValue[] loadArgs = new NamedValue[1];
        loadArgs[0]=new NamedValue();
        loadArgs[0].Name = "Value";
        loadArgs[0].Value = truncLP;

                                // inform all toolbars about new linestyle  
        sendCommandToAll("SetValues", loadArgs);

        //## also to all toolbars for this one, NB also used in this.Init
        jBorderLiner.TB_LSPreview.setLinestyle(truncLP);
    }
    
    
    /**
     */
//    com.sun.star.table.BorderLine GetLineStyle() {
//        com.sun.star.table.BorderLine BL = new BorderLine();
//        BL.OuterLineWidth = LSList[icurrentLinestyle][0];
//        BL.InnerLineWidth = LSList[icurrentLinestyle][1];
//        BL.LineDistance   = LSList[icurrentLinestyle][2];
//        BL.Color          = 0;
//        return BL;
//    }

    /** GetLineStyle for BorderLine2
     * @return icurrentLinestyle
     */
    short GetLineStyle2() {
//    	System.out.println("GetLineStyle2: "+icurrentLinestyle);
        return icurrentLinestyle;
    }
    
    /** set line style
     * need to write value to toolbar again in case user entered data manually
     * and also to inform all toolbars of the change
     * 
     * @param iLS - Linestyle
     */
    void setLineNumber(int iLS) {
        icurrentLinestyle = (short) iLS; 
//        System.out.println("setLineNumber: "+iLS);
    	int iLP = LineStyleToListPos(iLS);
        NamedValue[] loadArgs = new NamedValue[1];
        loadArgs[0]=new NamedValue();
        loadArgs[0].Name = "Value";
        
        loadArgs[0].Value = iLP;

                                // inform all toolbars about new linestyle  
        sendCommandToAll("SetValues", loadArgs);

        //## also to all toolbars for this one, NB also used in this.Init
        jBorderLiner.TB_LSPreview.setLinestyle(iLP);
    }
    
    /**
     */
    short[][] GetLSList() {
        return LSList;
    }
    
    /** convert the LineStyle to the Position in the List
     * @param ListStyle
     * @return
     */
    short LineStyleToListPos (int LS) {
    	short LP;
        if (LS == com.sun.star.table.BorderLineStyle.NONE) {
        	LP = 0; }
        else { LP = (short) (LS+1); }
        return LP;
    }
    
    /** convert the LineStyle to the Position in the List
     * @param ListStyle
     * @return
     */
    short LinePosToLineStyle (short LP) {
    	short LS;
        if (LP == 0) 
        	{ LS = com.sun.star.table.BorderLineStyle.NONE; }
        else { LS = (short) (LP-1); }
        return LS;
    }
    
}