/*
 * BL_TB_SelectLWBtn.java
 * Created on 4. February 2012
 * BorderLiner Toolbar Active Button, Select Linewidth
 */

package name.dhiller.jBorderLiner;

import com.sun.star.beans.NamedValue;
//import com.sun.star.table.BorderLine;
import java.lang.Math;

/**
 * @author Dhiller
 * @version 120204
 */
class BL_TB_SelectLWBtn extends BL_ToolbarItem {
	//
    //private static com.sun.star.frame.XFrame mxFrame; // never read locally
    static int icurrentLineWidth;
                                // OuterLineWidth, InnerLineWidth, LineDistance
//    private static final short[][] LSList = { {0,0,0}, {35,0,0}, {2,0,0}, {18,0,0},
//        {88,0,0}, {141,0,0}, {176,0,0}, {2,2,35}, {2,2,88}, {35,35,35}, 
//        {88,88,88}, {35,2,88}, {88,2,88}, {141,2,88}, {88,35,88}, {35,88,35}, 
//        {141,88,88}, {88,141,88} };
    private static final double iInitialValue = 0.25;
    private static final double iLowerLimit = 0;
    private static final double iStep = 0.25;
    private static final double iUpperLimit = 9;
    
    /** Creates a new instance of BL_TB_ActiveBtn */
    BL_TB_SelectLWBtn() {
        super();
        icurrentLineWidth = LinePt2LineWidth(iInitialValue);
    }
    
    /** init - Initialize Toolbarbutton to select the linestyle
     * @param xFrame
     * @param com.sun.star.frame.XStatusListener xControl
     * @param com.sun.star.util.URL my URL
     *{@inheritDoc}
     */
    void Init(com.sun.star.frame.XFrame xFrame,
              com.sun.star.frame.XStatusListener xControl,
              com.sun.star.util.URL aURL) {

       super.Init (xFrame, xControl, aURL, null);

       NamedValue[] loadArgs = new NamedValue[4];

       loadArgs[0]=new NamedValue();
       loadArgs[0].Name = "Step";
       loadArgs[0].Value = iStep;
                
       loadArgs[1]=new NamedValue();
       loadArgs[1].Name = "LowerLimit";
       loadArgs[1].Value = iLowerLimit;

       loadArgs[2]=new NamedValue();
       loadArgs[2].Name = "UpperLimit";
       loadArgs[2].Value = iUpperLimit;
 
       loadArgs[3]=new NamedValue();
       loadArgs[3].Name = "Value";
       loadArgs[3].Value = LineWidth2LinePt(icurrentLineWidth);

       // new toolbar, need only to inform this of the value the others already have
       SendCommandTo(xControl, new String("SetValues"), loadArgs);
    }
    
    /** dispatch - got a message, linewidth changed, get value and set to all
     * @param com.sun.star.util.URL my URL
     * @param com.sun.star.beans.PropertyValue[] Arguments, Name = "KeyModifier", "Value"
     */
    void dispatch( com.sun.star.util.URL aURL,
                           com.sun.star.beans.PropertyValue[] aArguments) {
       int i;
       String sValue = new String();
       for (i=0; i < aArguments.length; i++) {
           if (aArguments[i].Name.equals("Value")) {
               sValue = aArguments[i].Value.toString();
               break;
           }
       }
       
       if (!sValue.equals(null)) {
//    	   System.out.println("LW: "+sValue);
           setLineWidthFromTB(Double.parseDouble(sValue));
       }
    }
    
    /** return the linewidth
     */
    //
    int GetLineWidth() {
        return icurrentLineWidth;
    }
    
    /** set line Width from the toolbar
     * need to write value to toolbar again in case user entered data manually
     * and also to inform all toolbars of the change
     * 
     * @param iLw - LineWidth
     */
    //
    void setLineWidthFromTB(double dLWPt) {
        dLWPt = Math.min(iUpperLimit, dLWPt);
        dLWPt = Math.max(iLowerLimit, dLWPt);
    	
        NamedValue[] loadArgs = new NamedValue[1];
        loadArgs[0]=new NamedValue();
        loadArgs[0].Name = "Value";
        loadArgs[0].Value = dLWPt;

                                // inform all toolbars about new linestyle  
        sendCommandToAll("SetValues", loadArgs);

    	icurrentLineWidth = LinePt2LineWidth(dLWPt);
    }

    /** set line Width
     * need to write value to toolbar again in case user entered data manually
     * and also to inform all toolbars of the change
     * 
     * @param iLw - LineWidth
     */
    //
    void setLineWidth(int iLW) {
    	icurrentLineWidth = iLW;
        
        NamedValue[] loadArgs = new NamedValue[1];
        loadArgs[0]=new NamedValue();
        loadArgs[0].Name = "Value";
        loadArgs[0].Value = LineWidth2LinePt(iLW);
//        System.out.println(iLW+"-"+LineWidth2LinePt(iLW));

                                // inform all toolbars about new linestyle  
        sendCommandToAll("SetValues", loadArgs);
    }
    
    /** Convert Linewidth in Points to LineWidth(LibreOffice)
     * @param dPt
     * @return
     */
    int LinePt2LineWidth (double dPt) {
    	return (int) Math.round(dPt*35.0);
    }
    
    /** Convert LineWidth(LibreOffice) to Linewidth in Points 
     * @param Linewidth
     * @return Linewidth in Points (multiples of 0.25)
     */
    double LineWidth2LinePt (int iLW) {
    	double d = Math.round(iLW/35.0/0.25); 
//    	System.out.println(d);
    	return (d*0.25);
    }
 
}