package name.dhiller.jBorderLiner;

import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;
import com.sun.star.lib.uno.helper.Factory;
import com.sun.star.lib.uno.helper.WeakBase;
import com.sun.star.lang.XSingleComponentFactory;
import com.sun.star.registry.XRegistryKey;
import name.dhiller.ooo.OOoRegistry.OOoRegistry;

/** BorderLiner
 * @author D. Hiller
 * @version 2.1.2
 * @since OOo 2.2 (localized dialog)
 * @since LibreOffice 3.3.1 (borders)
 */
public final class jBorderLiner extends WeakBase
   implements com.sun.star.lang.XServiceInfo,
              com.sun.star.frame.XDispatchProvider,
              com.sun.star.lang.XInitialization,
              com.sun.star.frame.XDispatch

{
    private final XComponentContext m_xContext;
    private com.sun.star.lang.XMultiComponentFactory m_xServiceManager = null;
    private com.sun.star.frame.XFrame m_xFrame;
    private static final String m_implementationName = jBorderLiner.class.getName();
    private static final String[] m_serviceNames = { "com.sun.star.frame.ProtocolHandler" };
    private static final String sPackageName = "name.dhiller.jBorderLiner";
    public static final boolean bDebug = true; // for debugging
                 // Toolbaritems, need to be static (1 per class not per object)
    public static BL_TB_ActiveBtn     TB_Active;
    public static BL_TB_ApplyToBtn    TB_ApplyTo;
    public static BL_TB_LSPreviewBtn  TB_LSPreview;
    public static BL_TB_SelectLSBtn   TB_SelectLS;
    public static BL_TB_SelectLWBtn   TB_SelectLW;
    public static BL_TB_SelectColorBtn TB_SelectColor;
    static String sImageDir;
    static String sDlgDir; // directory of the dialog
    static String sDlgName;
    static String sDlgHue;
    static boolean bMouseHandling;
    
    public jBorderLiner( XComponentContext context )
    { 
        m_xContext = context;
        m_xServiceManager = context.getServiceManager();
    };

    public static XSingleComponentFactory __getComponentFactory( String sImplementationName ) {
        XSingleComponentFactory xFactory = null;

        if ( sImplementationName.equals( m_implementationName ) )
            xFactory = Factory.createComponentFactory(jBorderLiner.class, m_serviceNames);
        return xFactory;
    }

    public static boolean __writeRegistryServiceInfo( XRegistryKey xRegistryKey ) {
        return Factory.writeRegistryServiceInfo(m_implementationName,
                                                m_serviceNames, xRegistryKey);
    }

    // com.sun.star.lang.XServiceInfo:
    public String getImplementationName() {
         return m_implementationName;
    }

    public boolean supportsService( String sService ) {
        int len = m_serviceNames.length;

        for( int i=0; i < len; i++) {
            if (sService.equals(m_serviceNames[i]))
                return true;
        }
        return false;
    }

    public String[] getSupportedServiceNames() {
        return m_serviceNames;
    }

    // com.sun.star.frame.XDispatchProvider:
    public com.sun.star.frame.XDispatch queryDispatch( com.sun.star.util.URL aURL,
           String sTargetFrameName, int iSearchFlags )
    {
        if ( aURL.Protocol.compareTo("name.dhiller.jBorderLiner:") == 0 )
        {
            if ( aURL.Path.compareTo("BorderLiner") == 0 )
                return this;
            if ( aURL.Path.compareTo("ApplyTo") == 0 )
                return this;
            if ( aURL.Path.compareTo("LSPreview") == 0 )
                return this;
            if ( aURL.Path.compareTo("SelectLS") == 0 )
                return this;
            if ( aURL.Path.compareTo("SelectLW") == 0 )
                return this;
            if ( aURL.Path.compareTo("SelectColor") == 0 )
                return this;
        }
        return null;
    }

    // com.sun.star.frame.XDispatchProvider:
    public com.sun.star.frame.XDispatch[] queryDispatches(
         com.sun.star.frame.DispatchDescriptor[] seqDescriptors )
    {
        int nCount = seqDescriptors.length;
        com.sun.star.frame.XDispatch[] seqDispatcher =
            new com.sun.star.frame.XDispatch[seqDescriptors.length];

        for( int i=0; i < nCount; ++i )
        {
            seqDispatcher[i] = queryDispatch(seqDescriptors[i].FeatureURL,
                                             seqDescriptors[i].FrameName,
                                             seqDescriptors[i].SearchFlags );
        }
        return seqDispatcher;
    }

    // com.sun.star.lang.XInitialization:
    public void initialize( Object[] object )
        throws com.sun.star.uno.Exception
    {
        if ( object.length > 0 )
        {
            m_xFrame = (com.sun.star.frame.XFrame)UnoRuntime.queryInterface(
                com.sun.star.frame.XFrame.class, object[0]);
        }
    }

    // com.sun.star.frame.XDispatch:
     public void dispatch( com.sun.star.util.URL aURL,
                           com.sun.star.beans.PropertyValue[] aArguments )
    {
         if ( aURL.Protocol.compareTo("name.dhiller.jBorderLiner:") == 0 )
        {
            if ( aURL.Path.compareTo("BorderLiner") == 0 )
            {
                TB_Active.dispatch(aURL, aArguments, m_xFrame);
                return;
            }
            if ( aURL.Path.compareTo("ApplyTo") == 0 )
            {
                TB_ApplyTo.dispatch(aURL, aArguments);
                return;
            }
            if ( aURL.Path.compareTo("LSPreview") == 0 )
            {
                TB_LSPreview.dispatch(aURL, aArguments);
                return;
            }
            if ( aURL.Path.compareTo("SelectLS") == 0 )
            {
                TB_SelectLS.dispatch(aURL, aArguments);
                return;
            }
            if ( aURL.Path.compareTo("SelectLW") == 0 )
            {
                TB_SelectLW.dispatch(aURL, aArguments);
                return;
            }
            if ( aURL.Path.compareTo("SelectColor") == 0 )
            {
                TB_SelectColor.dispatch(aURL, aArguments);
                return;
            }
        }
    }

    public void addStatusListener( com.sun.star.frame.XStatusListener xControl,
                                    com.sun.star.util.URL aURL )
    {
        // initializing the buttons
        if ( aURL.Protocol.compareTo("name.dhiller.jBorderLiner:") == 0 )
        {
            if ( aURL.Path.compareTo("BorderLiner") == 0 ) 
            {
                if (TB_Active == null) TB_Active = new BL_TB_ActiveBtn();
                OOoRegistry tempBLRegistry = new OOoRegistry(m_xContext);
                String s = tempBLRegistry.getString(sPackageName, "Settings", "MouseHandling");
                bMouseHandling = (s.compareTo("true") == 0);
                
                TB_Active.Init(m_xFrame, xControl, aURL, m_xContext, bMouseHandling);
            }
            if ( aURL.Path.compareTo("ApplyTo") == 0 ) // Dropdownbutton
            {
                if (TB_ApplyTo == null) TB_ApplyTo = new BL_TB_ApplyToBtn();
                TB_ApplyTo.Init(m_xContext, m_xFrame, xControl, sPackageName, aURL);
            }
            if ( aURL.Path.compareTo("LSPreview") == 0 )    // ImageButton
            {
                OOoRegistry tempBLRegistry = new OOoRegistry(m_xContext);
                sImageDir = tempBLRegistry.getValue(sPackageName, "Settings", "ImageDir");
                //if (bDebug) System.out.println("sImageDir"+sImageDir);
                if (TB_LSPreview == null) TB_LSPreview = new BL_TB_LSPreviewBtn();
                TB_LSPreview.Init(m_xFrame, xControl, aURL, sImageDir);   
            }
            if ( aURL.Path.compareTo("SelectLS") == 0 )     // Spinfield
            {
                if (TB_SelectLS == null) TB_SelectLS = new BL_TB_SelectLSBtn();
                TB_SelectLS.Init(m_xFrame, xControl, aURL);
            }
            if ( aURL.Path.compareTo("SelectLW") == 0 )     // Spinfield Select Linewidth
            {
                if (TB_SelectLW == null) TB_SelectLW = new BL_TB_SelectLWBtn();
                TB_SelectLW.Init(m_xFrame, xControl, aURL);
            }
            if ( aURL.Path.compareTo("SelectColor") == 0 )  
            {   
                OOoRegistry tempBLRegistry = new OOoRegistry(m_xContext);
                sDlgDir = tempBLRegistry.getValue(sPackageName, "Settings", "ColorChooserDir");
                sDlgName = tempBLRegistry.getValue(sPackageName, "Settings", "ColorChooserDlg");
                sDlgHue = tempBLRegistry.getValue(sPackageName, "Settings", "ColorChooserHue");
                if (TB_SelectColor == null) TB_SelectColor = new BL_TB_SelectColorBtn();
                // System.out.println("TB_SelectColor="+ TB_SelectColor);
                TB_SelectColor.Init(m_xFrame, xControl, aURL, sDlgDir, sDlgName, sDlgHue,
                        m_xContext);            
            }
        }
        //ListenerHelper.AddListener(m_xFrame, xControl, aURL.Path);  //## can be removed
    }

    public void removeStatusListener( com.sun.star.frame.XStatusListener xControl,
                                       com.sun.star.util.URL aURL )
    {
        if ( aURL.Protocol.compareTo("name.dhiller.jBorderLiner:") == 0 )
        {
            if ( aURL.Path.compareTo("BorderLiner") == 0 )  // active button
            {
                TB_Active.removeContext(xControl, aURL);
            }
            if ( aURL.Path.compareTo("ApplyTo") == 0 ) // Dropdownbutton
            {
                TB_ApplyTo.removeContext(xControl, aURL);
            }
            if ( aURL.Path.compareTo("LSPreview") == 0 )    // ImageButton
            {
                TB_LSPreview.removeContext(xControl, aURL);
            }
            if ( aURL.Path.compareTo("SelectLS") == 0 )     // Spinfield
            {
                TB_SelectLS.removeContext(xControl, aURL);
            }
            if ( aURL.Path.compareTo("SelectLW") == 0 )     // Spinfield Select Linewidth
            {
                TB_SelectLW.removeContext(xControl, aURL);
            }
            if ( aURL.Path.compareTo("SelectColor") == 0 )  
            {   
                TB_SelectColor.removeContext(xControl, aURL);
            }
        }
        //ListenerHelper.RemoveListener( m_xFrame, xControl, aURL.Path );
    }
    
}